<template>
  <q-page class="row justify-center content-start bg-blue-grey-1 q-pa-xl">
    <div class="row justify-between col-12 q-pb-lg">
      <div
        class="text-h4 text-bold text-primary self-end"
        v-text="'Usuários'"
      />

      <q-btn
        :to="{ name: 'profile', params: { userId: null } }"
        class="super-rounded-borders"
        style="width: 272px"
        label="Novo Usuário"
        color="primary"
        padding="14px"
      />
    </div>

    <table-view
      class="col-12"
      sort-by="id"
      :columns="columns"
      :table-data="tableData"
      @reload="asyncReload('tableData')"
    />
  </q-page>
</template>

<script>
import { formatToCPF, formatToDate, formatToPhone } from 'brazilian-values'
import TableView from 'components/user/table-view'

export default {
  name: 'PageUsers',
  components: { TableView },
  asyncData: {
    tableDataDefault: [],
    async tableData () {
      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          url: '/Usuarios'
        }

        return this.$axios(axiosConfig).then(R => R.data)
      } catch (err) {
        this.axiosCatch(err)

        return undefined
      } finally {
        this.$q.loading.hide()
      }
    }
  },
  data () {
    return {
      lstACL: {
        root: 'Super Administrador',
        admin: 'Administrador',
        teacher: 'Professor',
        undefined: 'Aluno'
      },
      columns: [
        { name: 'id', field: 'id', label: '#', align: 'left', sortable: true },
        { name: 'name', field: 'name', label: 'Nome', align: 'left', sortable: true },
        { name: 'documentNumber', field: 'documentNumber', label: 'CPF', align: 'left', sortable: true, format: (val) => formatToCPF(val) },
        { name: 'bornAt', field: 'bornAt', label: 'Data de Nascimento', align: 'left', sortable: true, format: (val) => formatToDate(new Date(val)) },
        { name: 'phone', field: 'phone', label: 'Telefone', align: 'left', sortable: true, format: (val) => formatToPhone(val.ddd + val.number) },
        { name: 'email', field: 'email', label: 'E-mail', align: 'left', sortable: true },
        { name: 'lstACL', field: 'lstACL', label: 'Nível de Acesso', align: 'left', sortable: true, format: (val) => this.lstACL[val[0]] },
        { name: 'avatar', field: 'avatar', label: 'Foto', align: 'left', sortable: true },
        { name: 'createdAt', field: 'createdAt', label: 'Data de Cadastro', align: 'left', sortable: true, format: (val) => formatToDate(new Date(val)) },
        { name: 'action', field: 'action', label: 'Ações', align: 'center' }
      ]
    }
  }
}
</script>
